
GammaLib - Bug #1239

GModelSpatialEllipticalDisk Integration

07/01/2014 02:56 PM - Buehler Rolf

Status: Closed Start date: 07/01/2014

Priority: Normal Due date:  

Assigned To: Buehler Rolf % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: 00-09-00   

Description

When generating a model map or fitting a GModelSpatialEllipticalDisk object the following warning appears many times:

+++ WARNING in GIntegral::romb(-0.512902, 0.512902, 5): Integration uncertainty 6519.05 exceeds tolerance of 1073.84 after 21

iterations. Result 1.07384e+08 is inaccurate.

And the model map/fit appears to never to finish/converge.

This does not happen when exchanging the spatial model to GModelSpatialRadialDisk or  GModelSpatialRadialGauss. For them the

the model map/fit is done within 1-2 mins, while for the GModelSpatialEllipticalDisk after ~two hours there is still only warnings and

no conversion.

I attach a script which reproduces the error (the DESY caldb response is also attached and assumed to be in the same folder as the

script)

Related issues:

Related to GammaLib - Action # 1291: Finish implementation of stacked cube an... Closed 07/23/2014

Related to GammaLib - Bug # 1299: Fitting problems with radial disk model Closed 07/25/2014

History

#1 - 07/20/2014 11:15 PM - Knödlseder Jürgen

- Project changed from ctools to GammaLib

#2 - 07/25/2014 01:35 AM - Knödlseder Jürgen

- Status changed from New to In Progress

- Assigned To set to Buehler Rolf

- Target version set to 00-09-00

- % Done changed from 0 to 50

I guess this works now (see #1291), but we still need to check that the problem is indeed solved. Rolf, can you pull out the latest code from devel and

check whether the problem is now fixed?

#3 - 07/25/2014 10:01 AM - Buehler Rolf

- File crabextent.py added

I have checked out the newest devel branch of ctools and gamma-lib but it still does not work (25th of July). I attach the script I use (it requires the

caldb files linked above). For an Gaussian model the fit converges in ~6 mins. For the elliptical model it has still not converged after ~35 mins (I will let

it run some more and post here in case it converges at the end). Also, I still get a long list of warnings:

+++ WARNING in GIntegral::romb(0, 6.28319, 5): Integration uncertainty 3.9496e+11 exceeds absolute tolerance of 1.68813e+11 after 21 iterations.

Result 1.68813e+16 is inaccurate.
#4 - 10/30/2014 11:27 AM - Knödlseder Jürgen

- File crabextent.py added

- File ctlike.log added

- Status changed from In Progress to Feedback

- % Done changed from 50 to 100

I think this is now solved (see code in devel). After slightly adapting your script to my environment (see attachment:crabextent.py) I get the following

output:

$ time ./crabextent.py

Deleting directory: ellipdisk

ellipdisk: Starting. Obstime is 1800.0 s

ellipdisk: (elapsed: 2.14576721191e-06 s)

ellipdisk: Simulated..

ellipdisk: (elapsed: 5.43468785286 s)

ellipdisk: Created counts map..

ellipdisk: (elapsed: 0.861178159714 s)

ellipdisk: Created model map..

ellipdisk: (elapsed: 9.28993296623 s)

ellipdisk: Fitted..

ellipdisk: (elapsed: 115.408593893 s)

TS is 13012.9857907

real    2m11.373s

user    2m9.717s

sys    0m1.064s

hence the job is done on my Mac within 2 minutes. I also attach the ctlike log file that I got: attachment:ctlike.log

I put the issue now on feedback. If I won't hear back from you I will consider it closed for the next release.

#5 - 11/11/2014 11:19 PM - Knödlseder Jürgen

- Status changed from Feedback to Closed
Close that now.

Files

ellipse_example.py 1.94 KB 07/01/2014 Buehler Rolf

caldb.zip 76 KB 07/01/2014 Buehler Rolf

crabextent.py 6.43 KB 07/25/2014 Buehler Rolf

crabextent.py 6.4 KB 10/30/2014 Knödlseder Jürgen

ctlike.log 13 KB 10/30/2014 Knödlseder Jürgen
